<?php
    
add_action( 'admin_enqueue_scripts', 'register_scripts' );
add_action( 'wp_ajax_nopriv_get_list_mailwizz', 'action_get_list_to_mailwizz' );
add_action( 'wp_ajax_get_list_mailwizz', 'action_get_list_to_mailwizz' );


add_action('admin_menu', 'element_mailwizz_plugin_create_menu');

add_action( 'wp_ajax_nopriv_get_list_mailwizz', 'action_get_list_to_mailwizz' );
add_action( 'wp_ajax_get_list_mailwizz', 'action_get_list_to_mailwizz' );



function register_scripts(){
    wp_enqueue_script( 'element-mailwizz-admin',
        element_mailwizz_plugin_url( 'assets/js/setting.js' ),
        array( 'jquery', 'jquery-ui-tabs' ),
        1.0, true
    );
    wp_enqueue_style ('elementor-mailwizz-style', element_mailwizz_plugin_url('assets/css/style.css'), array(), '5.1.6');

}


function element_mailwizz_plugin_create_menu() {

    //create new top-level menu
    add_menu_page('Elementor Ohwo', 'Elementor Ohwo', 'administrator', __FILE__, 'element_mailwizz_plugin_settings_page'  );

    //call register settings function
    add_action( 'admin_init', 'register_element_mailwizz_plugin_settings' );
}


function register_element_mailwizz_plugin_settings() {
    //register our settings
    register_setting( 'element-mailwizz-plugin-settings-group', 'api_public_key' );
    register_setting( 'element-mailwizz-plugin-settings-group', 'api_private_key' );
    register_setting( 'element-mailwizz-plugin-settings-group', 'api_url' );
    register_setting( 'element-mailwizz-plugin-settings-group', 'list_default' );
    register_setting( 'element-mailwizz-plugin-settings-group', 'lists_list' );
}

function element_mailwizz_plugin_settings_page() {
    $listsListOption = get_option('lists_list');
    $listsList =[];
    if($listsListOption){
        $listsList = json_decode($listsListOption);
    }
    ?>
    <div class="wrap" id="elementor-mailwizz-setting">
        <h1>Elementor OHWO Setting</h1>
        <form method="post" action="options.php">
            <?php settings_fields( 'element-mailwizz-plugin-settings-group' ); ?>
            <?php do_settings_sections( 'element-mailwizz-plugin-settings-group' ); ?>
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">API URL</th>
                    <td><input type="text" readonly="readonly" name="api_url" value="https://app.ohwo.com/apiwrap/index.php" /></td>
                </tr>

                <tr valign="top">
                    <th scope="row">API Public Key</th>
                    <td><input type="text" name="api_public_key" value="<?php echo esc_attr( get_option('api_public_key') ); ?>" />  </td>
                </tr>

                <tr valign="top">
                    <th scope="row">API Private Key</th>
                    <td><input type="text" name="api_private_key" value="<?php echo esc_attr( get_option('api_private_key') ); ?>" />  </td>
                </tr>

                <tr valign="top">
                    <th scope="row">Default List</th>
                    <td>
                        <select name="list_default" >
                            <option value="">Choose List</option>
                            <?php if(count($listsList) >0): ?>
                                <?php foreach ($listsList as $list): ?>
                                    <option <?=$list->id == get_option('list_default') ? 'selected' : '' ?> value="<?=$list->id?>"><?=$list->name?></option>
                                <?php endforeach; ?>
                            <?php endif; ?>
                        </select> - <a id="get_list" href="javascript:void(0);" class="btn">Get Lists</a>
                    </td>
                </tr>
                <input type="hidden" name="lists_list" value="<?php echo esc_attr( get_option('lists_list') ); ?>"/>
            </table>

            <?php submit_button(); ?>

        </form>
    </div>
<?php } 
function action_get_list_to_mailwizz() {
    global $wpdb; // this is how you get access to the database
    $url = $_POST['url'];
    $public_key = $_POST['public_key'];
    $private_key = $_POST['private_key'];
    $response = Requests::get($url.'/lists/show',['public-key'=>$public_key,'private-key'=>$private_key]);
    if($response->status_code == 200){
        $data = json_decode($response->body);
        if($data->status == 'success'){
            $result = [];
            $records = $data->data->records;
            foreach ($records as $record){
                $result[] = [
                    'id'=>$record->general->list_uid,
                    'name' => $record->general->name
                ];
            }
            echo json_encode($result);
        }
        wp_die();
    }

    wp_die();
}

function element_mailwizz_plugin_url( $path = '' ) {
    $url = plugins_url( $path, ELEMENT_MAILWIZZ_PLUGIN );

    if ( is_ssl()
        and 'http:' == substr( $url, 0, 5 ) ) {
        $url = 'https:' . substr( $url, 5 );
    }

    return $url;
}